unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, UTrayIcon, Menus, ExtCtrls, Math,
  uUtils;

type
  TfMain = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label1: TLabel;
    shControl: TShape;
    shShift: TShape;
    shWin: TShape;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    cbChar: TComboBox;
    lbHotKey: TListBox;
    eInterval: TEdit;
    Label5: TLabel;
    shInterval: TShape;
    sbSave: TSpeedButton;
    sbLoad: TSpeedButton;
    lbActions: TListBox;
    Label6: TLabel;
    cbActions: TComboBox;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    eTargetName: TEdit;
    SpeedButton10: TSpeedButton;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure pmTrayPopup(Sender: TObject);
    procedure shIntervalMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure sbSaveClick(Sender: TObject);
    procedure sbLoadClick(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure lbHotKeyClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    procedure WMHotKey(var msg:TWMHotKey);message WM_HotKey;
    procedure WMOnActivate(var msg:TWMActivateApp);message WM_ACTIVATEAPP;
    procedure FindTargetWindow(Sender:TObject);
  public
    { Public declarations }
  end;

  TActionType=(SetTab,UseCell,Say,Pause);
  TTimerType=(None,Started,Stopped);

  TAction=record
    _Type:TActionType;
    Num:byte;
    _String:string;
  end;

  TMyHotKey=object
    ID:integer;
    _Timer:TTimerType;
    Timer:TTimer;
    _Shift:boolean;
    _Control:boolean;
    _Win:boolean;
    _Char:Char;
    Actions:array of TAction;
    procedure Go(Sender: TObject);
  end;

var
  fMain: TfMain;
  HotKeys:array of TMyHotKey;
  StopAll:boolean;
  TargetName:String;
  TargetWnd:cardinal;
  TimerToSearch:TTimer;
  ProgDir:string;

implementation

{$R *.dfm}

procedure Delay(sec:dword);
var
  EndTime:dword;
begin
  EndTime:=GetTickCount+(sec*1000);
  repeat
  Application.ProcessMessages;
  until GetTickCount>EndTime;
end;

procedure TfMain.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If Button = mbLeft Then
  Begin
    ReleaseCapture;
    SendMessage(Handle,WM_NCLBUTTONDOWN,HTCAPTION,0);
  End
end;

procedure TfMain.FormCreate(Sender: TObject);
var i:char;
    j:byte;
begin
  ProgDir:=ExtractFileDir(ParamStr(0));
  Color:=clBlack;
  Font.Color:=clLime;
  for i:='A' to 'Z' do begin
    cbChar.Items.Add(i);
  end;
  for i:='0' to '9' do begin
    cbChar.Items.Add(i);
  end;

  for j:=1 to 10 do
  cbActions.Items.Add('.  '+inttostr(j));
  for j:=1 to 12 do
  cbActions.Items.Add('.  '+inttostr(j));
  cbActions.Items.Add('');
  cbActions.Items.Add('');
end;

procedure TfMain.FormPaint(Sender: TObject);
var i:byte;
begin
  Canvas.Pen.Color:=clRed;
  Canvas.MoveTo(0,0);
  Canvas.LineTo(fMain.ClientWidth-1,0);
  Canvas.LineTo(fMain.ClientWidth-1,fMain.ClientHeight-1);
  Canvas.LineTo(0,fMain.ClientHeight-1);
  Canvas.LineTo(0,0);
  Canvas.MoveTo(fMain.ClientWidth-1,20);
  Canvas.LineTo(0,20);
  Canvas.MoveTo(fMain.ClientWidth div 2,20);
  Canvas.LineTo(fMain.ClientWidth div 2,fMain.ClientHeight-1);
  Canvas.MoveTo(1,1);
  for i:=1 to 20 do begin
    Canvas.Pen.Color:=
    RGB(255,255-i*10,255-i*10);
    Canvas.MoveTo(1,i);
    Canvas.LineTo(fMain.ClientWidth-1,i);
  end;
  Canvas.Brush.Style:=bsClear;
  Canvas.Font.Color:=clBlack;
  Canvas.TextOut(5,3,'L2 Short Key by Gott aka deGreese');
  Canvas.Font.Color:=clRed;
  Canvas.TextOut(4,2,'L2 Short Key by Gott aka deGreese');
end;

procedure TfMain.SpeedButton3Click(Sender: TObject);
begin
  Halt;
end;

procedure TfMain.SpeedButton1Click(Sender: TObject);
begin
  Application.Minimize;
end;

procedure TfMain.pmTrayPopup(Sender: TObject);
begin
  Application.Restore;
end;

procedure TfMain.shIntervalMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not(Sender is TShape)then exit;
  (Sender as TShape).Tag:=byte(not bool((Sender as TShape).Tag));
  (Sender as TShape).Brush.Color:=clRed*(Sender as TShape).Tag;
end;

{ TMyHotKey }

procedure TMyHotKey.Go(Sender: TObject);
var i:byte;

  function CreateLParam(VK:byte;TypeOfKey:byte):cardinal;
  var tmp:cardinal;
  begin
    tmp:=MapVirtualKey(VK,0);
    tmp:=(tmp shl 16)or 1;
    case TypeOfKey of
      2:tmp:=tmp or (cardinal($C0) shl 24);
      3:tmp:=tmp or (cardinal($20) shl 24);
      4:tmp:=tmp or (cardinal($E0) shl 24);
    end;
    if VK=VK_MENU then tmp:=tmp and $DFFFFFFF;
    Result:=tmp;
  end;

  procedure pSetTab(Num:byte);
  begin
    PostMessage(TargetWnd,WM_SYSKEYDOWN,VK_MENU,
                CreateLParam(VK_MENU,3));
    PostMessage(TargetWnd,WM_SYSKEYDOWN,VK_F1+(Num-1),
                CreateLParam(VK_F1+(Num-1),3));
    PostMessage(TargetWnd,WM_SYSKEYUP,VK_F1+(Num-1),
                CreateLParam(VK_F1+(Num-1),4));
    PostMessage(TargetWnd,WM_KEYUP,VK_MENU,
                CreateLParam(VK_MENU,2));
  end;

  procedure pUseCell(Num:byte);
  begin
    PostMessage(TargetWnd,WM_KEYDOWN,VK_F1+(Num-1),0);
    PostMessage(TargetWnd,WM_KEYUP,VK_F1+(Num-1),0);
  end;

  procedure pSay(val:string);
  var i:byte;
  begin
    PostMessage(TargetWnd,WM_KEYDOWN,VK_RETURN,0);
    PostMessage(TargetWnd,WM_KEYUP,VK_RETURN,0);

    for i:=1 to length(val) do
    PostMessage(TargetWnd,WM_CHAR,ord(val[i]),0);

    PostMessage(TargetWnd,WM_KEYDOWN,VK_RETURN,0);
    PostMessage(TargetWnd,WM_KEYUP,VK_RETURN,0);
  end;

begin
  if(Length(Actions)=0)or(StopAll)then exit;
  for i:=0 to Length(Actions)-1 do
  case Actions[i]._Type of
    SetTab:pSetTab(Actions[i].Num);
    UseCell:pUseCell(Actions[i].Num);
    Say:pSay(Actions[i]._String);
    Pause:Delay(Actions[i].Num);
  end;
end;

procedure TfMain.WMHotKey(var msg: TWMHotKey);
var i:byte;
begin
  if Length(HotKeys)=0 then exit;
  for i:=0 to Length(HotKeys)-1 do
  if msg.HotKey=HotKeys[i].ID then begin
    case HotKeys[i]._Timer of
      None:HotKeys[i].Go(nil);
      Started:begin
        HotKeys[i]._Timer:=Stopped;
        HotKeys[i].Timer.Enabled:=false;
      end;
      Stopped:begin
        HotKeys[i].Go(nil);
        HotKeys[i]._Timer:=Started;
        HotKeys[i].Timer.Enabled:=true;
      end;
    end;
    break;
  end;
end;

procedure TfMain.WMOnActivate(var msg: TWMActivateApp);
begin
  StopAll:=msg.Active;
end;

procedure TfMain.SpeedButton4Click(Sender: TObject);
var tmp:string;
    tmpID:integer;
begin
  if cbChar.ItemIndex=-1 then exit;
  tmp:='';
  SetLength(HotKeys,length(HotKeys)+1);
  //  
  if shControl.Tag=1 then begin
    tmp:=tmp+'Ctrl ';
    HotKeys[Length(HotKeys)-1]._Control:=true;
  end;
  //  
  if shShift.Tag=1 then begin
    tmp:=tmp+'Shift ';
    HotKeys[Length(HotKeys)-1]._Shift:=true;
  end;
  //  
  if shWin.Tag=1 then begin
    tmp:=tmp+'Win ';
    HotKeys[Length(HotKeys)-1]._Win:=true;
  end;
  // 
  HotKeys[Length(HotKeys)-1]._Char:=cbChar.text[1];
  tmp:=tmp+cbChar.Text;
  //    
  if shInterval.Tag=1 then begin
    HotKeys[Length(HotKeys)-1].Timer:=TTimer.Create(nil);
    HotKeys[Length(HotKeys)-1].Timer.Enabled:=false;
    HotKeys[Length(HotKeys)-1].Timer.OnTimer:=
    HotKeys[Length(HotKeys)-1].Go;
    try
      HotKeys[Length(HotKeys)-1].Timer.Interval:=StrToInt(eInterval.Text);
    except
      HotKeys[Length(HotKeys)-1].Timer.Interval:=10000;
    end;
    tmp:=tmp+' ('+inttostr(HotKeys[Length(HotKeys)-1].Timer.Interval)+')';
    HotKeys[Length(HotKeys)-1]._Timer:=Stopped;
  end
  else HotKeys[Length(HotKeys)-1]._Timer:=None;
  //    
  tmpID:=GlobalAddAtom(PChar(inttostr(RandomRange(10000000,99999999))));
  with HotKeys[Length(HotKeys)-1] do
  RegisterHotKey(Handle,tmpID,
  (MOD_SHIFT * byte(_Shift)) or
  (MOD_CONTROL * byte(_Control)) or
  (MOD_WIN * byte(_Win)),ord(_Char));
  HotKeys[Length(HotKeys)-1].ID:=tmpID;
  lbHotKey.Items.Add(tmp);
  sbLoad.Enabled:=false;
end;

procedure TfMain.SpeedButton5Click(Sender: TObject);
begin
  if lbHotKey.ItemIndex=-1 then exit;
  if HotKeys[lbHotKey.ItemIndex]._Timer<>None then
  try
    HotKeys[lbHotKey.ItemIndex].Timer.Free;
  except end;

  UnregisterHotKey(Handle,HotKeys[lbHotKey.ItemIndex].ID);
  GlobalDeleteAtom(HotKeys[lbHotKey.ItemIndex].ID);

  HotKeys[lbHotKey.ItemIndex]:=HotKeys[Length(HotKeys)-1];
  SetLength(HotKeys,Length(HotKeys)-1);

  lbHotKey.Items[lbHotKey.ItemIndex]:=lbHotKey.Items[lbHotKey.Count-1];
  lbHotKey.Items.Delete(lbHotKey.Count-1);

  lbActions.Clear;
end;

procedure TfMain.SpeedButton10Click(Sender: TObject);
begin
  if TimerToSearch<>nil then TimerToSearch.Enabled:=false
  else begin
    TimerToSearch:=TTimer.Create(nil);
    TimerToSearch.OnTimer:=FindTargetWindow;
    TimerToSearch.Interval:=1000;
  end;
  TargetWnd:=0;
  TargetName:=eTargetName.Text;
  TimerToSearch.Enabled:=true;
end;

procedure TfMain.FindTargetWindow(Sender: TObject);
begin
  TargetWnd:=FindWindow(nil,PChar(TargetName));
  if TargetWnd>0 then begin
    TimerToSearch.Free;
    TimerToSearch:=nil;
  end;
end;

procedure TfMain.sbSaveClick(Sender: TObject);
var buf,i,j,k:cardinal;
    f:integer;
    s:string;
    sdSave:TSaveDialog;
begin//Save settings
  sdSave:=TSaveDialog.Create(nil);
  sdSave.InitialDir:=ProgDir;
  if not sdSave.Execute then begin sdSave.Free; exit; end;
  s:=sdSave.FileName; sdSave.Free;
  if length(trim(s))=0 then exit;
  f:=FileCreate(s);
  if f=-1 then exit;
  //   
  s:=eTargetName.Text;
  buf:=length(s);
  FileWrite(f,buf,1);
  for i:=1 to length(s) do FileWrite(f,s[i],1);
  //----------------------------
  buf:=length(HotKeys);FileWrite(f,buf,1);
  if length(HotKeys)>0 then
  for i:=0 to length(HotKeys)-1 do begin
    buf:=byte(HotKeys[i]._Timer);FileWrite(f,buf,1);
    if HotKeys[i]._Timer<>None then buf:=HotKeys[i].Timer.Interval
    else buf:=0;
    FileWrite(f,buf,4);
    buf:=byte(HotKeys[i]._Shift);FileWrite(f,buf,1);
    buf:=byte(HotKeys[i]._Control);FileWrite(f,buf,1);
    buf:=byte(HotKeys[i]._Win);FileWrite(f,buf,1);
    buf:=byte(HotKeys[i]._Char);FileWrite(f,buf,1);
    buf:=length(HotKeys[i].Actions);FileWrite(f,buf,1);
    if Length(HotKeys[i].Actions)<>0 then
    for j:=0 to Length(HotKeys[i].Actions)-1 do begin
      buf:=byte(HotKeys[i].Actions[j]._Type);FileWrite(f,buf,1);
      if HotKeys[i].Actions[j]._Type=Say then begin
        s:=HotKeys[i].Actions[j]._String;
        buf:=length(s);FileWrite(f,buf,1);
        for k:=1 to length(s) do begin
          buf:=byte(s[k]);FileWrite(f,buf,1);
        end;
      end
      else begin
        buf:=HotKeys[i].Actions[j].Num;
        FileWrite(f,buf,1);
      end;
    end;
  end;
  FileClose(f);
  sbLoad.Enabled:=false;
end;

procedure TfMain.sbLoadClick(Sender: TObject);
var buf,i,j,k,tmpID:cardinal;
    s:string;
    HL,AL,StrLen_:byte;
    f:integer;
    odOpen:TOpenDialog;
begin//Load settings
  odOpen:=TOpenDialog.Create(nil);
  odOpen.InitialDir:=ProgDir;
  if not odOpen.Execute then begin odOpen.Free; exit; end;
  s:=odOpen.FileName; odOpen.Free;
  if length(trim(s))=0 then exit;
  f:=FileOpen(s,fmOpenRead);
  if f=-1 then exit;
  //   
  s:='';
  FileRead(f,StrLen_,1);
  for i:=1 to StrLen_ do begin
    FileRead(f,buf,1);
    s:=s+char(buf);
  end;
  eTargetName.Text:=s;
  //---------------------------
  FileRead(f,buf,1);HL:=byte(buf);
  SetLength(HotKeys,HL);
  if HL>0 then
  for i:=0 to HL-1 do begin
    FileRead(f,buf,1);HotKeys[i]._Timer:=TTimerType(buf);
    FileRead(f,buf,4);
    if HotKeys[i]._Timer<>None then begin
      HotKeys[i].Timer:=TTimer.Create(nil);
      HotKeys[i].Timer.Interval:=buf;
      HotKeys[i].Timer.Enabled:=false;
      HotKeys[i].Timer.OnTimer:=HotKeys[i].Go;
    end;
    FileRead(f,buf,1); HotKeys[i]._Shift:=boolean(buf);
    FileRead(f,buf,1); HotKeys[i]._Control:=boolean(buf);
    FileRead(f,buf,1); HotKeys[i]._Win:=boolean(buf);
    FileRead(f,buf,1); HotKeys[i]._Char:=Char(buf);
    FileRead(f,AL,1); SetLength(HotKeys[i].Actions,AL);
    if AL>0 then
    for j:=0 to AL-1 do begin
      FileRead(f,buf,1); HotKeys[i].Actions[j]._Type:=TActionType(buf);
      if HotKeys[i].Actions[j]._Type=Say then begin
        FileRead(f,buf,1); StrLen_:=buf;
        s:='';
        for k:=1 to StrLen_ do begin
          FileRead(f,buf,1);
          s:=s+char(buf);
        end;
        HotKeys[i].Actions[j]._String:=s;
      end
      else begin
        FileRead(f,buf,1);
        HotKeys[i].Actions[j].Num:=buf;
      end;
    end;
    tmpID:=GlobalAddAtom(PChar(inttostr(RandomRange(10000000,99999999))));
    with HotKeys[i] do
    RegisterHotKey(Handle,tmpID,
    (MOD_SHIFT * byte(_Shift)) or
    (MOD_CONTROL * byte(_Control)) or
    (MOD_WIN * byte(_Win)),ord(_Char));
    HotKeys[i].ID:=tmpID;
  end;
  FileClose(f);

  s:='';
  for i:=0 to length(HotKeys)-1 do begin
    s:='';
    //  
    if HotKeys[i]._Control then s:=s+'Ctrl ';
    //  
    if HotKeys[i]._Shift then s:=s+'Shift ';
    //  
    if HotKeys[i]._Win then s:=s+'Win ';
    // 
    s:=s+HotKeys[i]._Char;
    //    
    if HotKeys[i]._Timer<>None then
    s:=s+' ('+inttostr(HotKeys[i].Timer.Interval)+')';
    lbHotKey.Items.Add(s);
  end;
  sbLoad.Enabled:=false;
end;

procedure TfMain.SpeedButton8Click(Sender: TObject);
var tmp:string;
begin
  if(cbActions.ItemIndex=-1)or(lbHotKey.ItemIndex=-1)then exit;
  tmp:='';
  with HotKeys[lbHotKey.ItemIndex] do begin
    SetLength(Actions,length(Actions)+1);
    case cbActions.ItemIndex of
      0..9:begin
        Actions[length(Actions)-1]._Type:=SetTab;
        Actions[length(Actions)-1].Num:=cbActions.ItemIndex+1;
        tmp:='.  '+inttostr(cbActions.ItemIndex+1);
      end;
      10..21:begin
        Actions[length(Actions)-1]._Type:=UseCell;
        Actions[length(Actions)-1].Num:=cbActions.ItemIndex-9;
        tmp:='.  '+inttostr(cbActions.ItemIndex-9);
      end;
      22:begin
        Actions[length(Actions)-1]._Type:=Say;
        if(not InputQuery('  ','',tmp))or
          (length(tmp)=0)
        then tmp:='I`m a bot!';
        Actions[length(Actions)-1]._String:=tmp;
        tmp:=' '+tmp;
      end;
      23:begin
        Actions[length(Actions)-1]._Type:=Pause;
        if(not InputQuery('','(0..255)',tmp))or
          (length(tmp)=0)
        then tmp:='5';//       .
        try           //   - 
          Actions[length(Actions)-1].Num:=StrToInt(tmp);
        except
          Actions[length(Actions)-1].Num:=5;
        end;
        tmp:=' '+tmp;
      end;
    end;//end case
  end;
  lbActions.Items.Add(tmp);
end;

procedure TfMain.SpeedButton9Click(Sender: TObject);
var i,j:integer;
begin
  i:=lbHotKey.ItemIndex;
  j:=lbActions.ItemIndex;
  if(i=-1)or(j=-1)then exit;
  SetLength(HotKeys[i].Actions,length(HotKeys[i].Actions)-1);
  lbActions.Items.Delete(lbActions.Count-1);
end;

procedure TfMain.lbHotKeyClick(Sender: TObject);
var i,j:integer;
    tmp:string;
begin
  i:=lbHotKey.ItemIndex;
  if i=-1 then exit;
  lbActions.Clear;
  if length(HotKeys[i].Actions)=0 then exit;
  for j:=0 to length(HotKeys[i].Actions)-1 do begin
    tmp:='';
    case HotKeys[i].Actions[j]._Type of
      SetTab:lbActions.Items.Add('.  '+
        inttostr(HotKeys[i].Actions[j].Num));
      UseCell:lbActions.Items.Add('.  '+
        inttostr(HotKeys[i].Actions[j].Num));
      Say:lbActions.Items.Add(' '+HotKeys[i].Actions[j]._String);
      Pause:lbActions.Items.Add(' '+inttostr(HotKeys[i].Actions[j].Num));
    end;
  end;
end;

procedure TfMain.FormDestroy(Sender: TObject);
var i:byte;
begin
  if length(HotKeys)=0 then exit;
  for i:=0 to length(HotKeys)-1 do begin
    if HotKeys[i]._Timer<>None then
    try
      HotKeys[i].Timer.Free;
    except end;
    UnregisterHotKey(Handle,HotKeys[i].ID);
    GlobalDeleteAtom(HotKeys[i].ID);
    lbHotKey.Items.Delete(0);
  end;
  SetLength(HotKeys,0);
end;

end.
